

// INCLUDE --------------------------------------------
#include <Servo.h>

// KLASSE ---------------------------------------------
class Pen{

private:

  Servo pen_motor;
  double loop_steps; // wie viele schritte im loop der stift braucht, um hoch und runter zu gehen, muss getestet werden

public: 

  void setup() {
    pen_motor.attach(30, 800, 2100); // Servo muss speziell eingerichtet werden
    loop_steps=0.0;
    up();
  }
  
  void loop() {
    if (loop_steps>0.0) {
      loop_steps--;
    } 
  }

  void up() {
    pen_motor.write(60);
    loop_steps=1000.0;
  }

  void down() {
    pen_motor.write(25);
    loop_steps=1000.0;
  }
  
  void setManuell(boolean should_be_up) {
    if (should_be_up) {
       up(); 
    } else {
       down(); 
    }
  }
  
  boolean getIsReady() {
     return (loop_steps<=0.0); 
  }

};

