

// INCLUDE --------------------------------------------
#include "Arduino.h"
//#include "TimerOne.h"

// KLASSE ---------------------------------------------
class Stepper{
  
private:

  //Motor
  int direction_pin;
  int step_pin;

  // Schritte
  unsigned long steps;
  unsigned long steps_total;
  
  // Geschwindigkeit
  unsigned long current_intervall; // wirkliche gesc, mit beschleunigung
  unsigned long beschl_start_mikros; 
  boolean is_hochpunkt;
  float v_start;
  unsigned long last_mikros;  //Zur Delay-freien Verarbeitung werden die...
  unsigned long current_mikros;  //seit Programmstart vergangenen Microsekunden
 
  float v_max;
  float manuell_v;
  
            float current_v;

  
  float v_a; // beschleunigung
 
  // Andere
  boolean is_working;

public:

  void setup(){ 

  }
  
  void pinSetup(int newdirection_pin, int newstep_pin){  //Motor-Setup
    direction_pin = newdirection_pin;  //Übergabe der in Funktion übergebenen Variablen
    step_pin = newstep_pin;
    pinMode(direction_pin, OUTPUT);
    pinMode(step_pin, OUTPUT);

    manuell_v=0.0;
    current_intervall=0;
    steps=0;
    steps_total=0;
    is_working=false;
    last_mikros=0;
    current_v=1.0;
    
  }
  
  void loop() {
    if(steps>0||manuell_v>0/*||current_v>0*/){
        current_mikros=micros();
        
        if(current_mikros-last_mikros>=current_intervall){
          last_mikros=current_mikros;
          digitalWrite(step_pin, true);
          delayMicroseconds(1);
          digitalWrite(step_pin, false);
          
          
          // step modus ---------------
          if (steps>0) {
            steps--;
          
            float t=(float)(current_mikros-beschl_start_mikros); // in mikroskunden
            t=t/1000000.0; // tin sekunden
            
            current_v = v_start + (!is_hochpunkt?v_a:v_a*-1)*t ;
            
            if (!is_hochpunkt&&steps<steps_total/2) { // hochpunkt
              is_hochpunkt=true;            
              v_start=current_v;     
              beschl_start_mikros=micros();       
            }          
            
            if (current_v<1.0) {
               current_v=1.0; 
            }
            
            if (current_v>v_max) {
              current_v=v_max;
            }
            
          }
          
          // man modus -------------------
         /* if (manuell_v>0) {
            if (current_v<manuell_v) {
               current_v=current_v+1.0; 
            }
            if (current_v>manuell_v) {
               current_v=current_v-1.0; 
            }
            //current_v=manuell_v;
          }*/
            current_v=manuell_v;

          // intervall ausrechnen --------
          float ti = 0.1767/current_v; // 1 step in mm
          ti=ti*1000000.0;
          current_intervall=ti;
          
      }
      if(steps<=0){ // motor ist fertig
        is_working=false;
      }
    }
  }

  void drive(float newDistance) { // in mm
    is_working=true;
    
    steps=fabs(newDistance/0.1767); // es wird runter gezählt
    steps_total=steps;

    beschl_start_mikros=micros();

    is_hochpunkt=false;
    v_start=0;

    if(newDistance>0){ // richtung festlegen
      digitalWrite(direction_pin,false);
    }
    else{
      digitalWrite(direction_pin,true);
    }
  }

  boolean getIsReady(){ // gibt an, ob motor "idle" ist
    return !is_working;
  }
  
  void setVMax(float new_vmax) {
     v_max=new_vmax; 
     v_a = v_max/2; // in mm/s^2  zb nach 1 sekunde 100mm/s
  }
  
  void setManuellV(float new_manuell_v) {
    if(new_manuell_v>0.0){ // richtung festlegen
      digitalWrite(direction_pin,false);
    }
    else{
      digitalWrite(direction_pin,true);
    }
    manuell_v=fabs(new_manuell_v); // egal ob + oder -, muss positiv sein, richtung wurde schon festgelegt
  }
  
};
